// predefined values of 'type' byte
#define TYPE_SOID 0xff
#define TYPE_UA 0xf1
#define TYPE_SA 0xf2
#define TYPE_OPKEY 0xf3
//....
#define TYPE_FLAGS 0x10 // sharing, static CW, preferred, etc.
#define TYPE_INFO  0x11 // maybe text data?
// ....
// for use with untyped CA ID
//#define TYPE_CAINFO 0xCA // current CAID for do_ecm, CAID from do_ecm, key in use, EMM flags and info, etc. 
#define TYPE_ADDRESS 0xAA // addresses of MHW variables for HDL.


#define LEN_BYTE 3
#define HEADER_LEN (LEN_BYTE+1)

/*
trailing 8 bytes of each buffer are reserved for service needs
*/
#define ECM2CARD_LOCK	0xffa	// 1: don't send ecm on card if do_ecm() fails. 
#define SECA_EMM_LOCK	0xffb	// 0: seca emms disabled, 1: SA/UA emms enabled, 2: SA emms enabled 
#define EMM_DISP_FLAG 	0xffc	// MHW flag to display/not display EMM info
#define EMM_UPD_FLAG 	0xffd	// EMM processing mode (if 0 then no emm processing, 1: display all keys, 2: display new keys)

#define BUF_END 	0xffe // last bytes of buffer, contains LE ptr to free space
#define BUF_SIZE (BUF_END+2)
#define DATA_END 	0xff7 // last byte of dynamic data



