//---------------------------------------------------------------------------

#pragma hdrstop

#include "hexutils.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

int hex2int(char c)
{
        //TODO: Add your source code here
        int i=-1;
        switch(c){
           case '0':i=0; break;
           case '1':i=1; break;
           case '2':i=2; break;
           case '3':i=3; break;
           case '4':i=4; break;
           case '5':i=5; break;
           case '6':i=6; break;
           case '7':i=7; break;
           case '8':i=8; break;
           case '9':i=9; break;
           case 'a':
           case 'A':i=10; break;
           case 'b':
           case 'B':i=11; break;
           case 'c':
           case 'C':i=12; break;
           case 'd':
           case 'D':i=13; break;
           case 'e':
           case 'E':i=14; break;
           case 'f':
           case 'F':i=15; break;
           default: i=-1;
        }
        return i;
}

int hex2bin(char* in, unsigned char* out)
{
        //TODO: Add your source code here
        int i, half, nibble;
        i=half=0;
        while(*in) {
            nibble=hex2int(*in);
            in++;
            if(nibble != -1) {
                 if(half) {
                     out[0] |= (nibble&0xf);
                     out++; i++;
                 }
                 else {
                     out[0] = nibble<<4;
                 }
                 half = (half+1)&1;
            }

        }
        return i;
}
// interpret hex string as little endian representation of integer
unsigned int hex2be(char* in, int char_count) {
    unsigned int out = 0;
    int i ;
    for(i = 0; i < char_count; i++) {
         out |= (hex2int(in[i]) << (4 * i));
    }
    return out;
}

// interpret hex string as big endian representation of integer
unsigned int hex2le(char* in, int char_count) {
    unsigned int out = 0;
    int i ;
    for(i = 0; i < char_count; i++) {
         out |= (hex2int(in[char_count - i - 1]) << (4 * i));
    }
    return out;
}


