//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *mnu;
	TMenuItem *File1;
	TMenuItem *Open1;
	TMenuItem *Save1;
	TMenuItem *Exit1;
	TOpenDialog *OpenDialog1;
	TSaveDialog *SaveDialog1;
	TMenuItem *N1;
	TMenuItem *Import1;
	TMenuItem *OldEMU1;
	TMenuItem *SoftCamkey1;
	TPageControl *pgInfo;
        TPanel *Panel2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TEdit *txtName;
        TEdit *txtUA;
        TEdit *txtSA;
        TEdit *txtOther;
        TGroupBox *GroupBox1;
        TCheckBox *chkPref;
        TCheckBox *chkShar;
        TCheckBox *chkDCW;
        TCheckBox *chk3;
        TListBox *lstIdents;
        TPanel *Panel5;
        TSpeedButton *SpeedButton5;
        TSpeedButton *SpeedButton6;
        TSpeedButton *SpeedButton7;
        TSpeedButton *SpeedButton8;
        TPanel *Panel6;
        TComboBox *lstCASys;
        TLabel *Label1;
	TTabSheet *shtKeys;
        TPanel *Panel3;
        TListBox *lstKeys;
	TPanel *panKey;
        TLabel *Label9;
        TLabel *lblKeyLen;
        TLabel *lblKeyVal;
        TEdit *txtKeyID;
        TEdit *txtKeyLen;
        TMemo *txtKeyVal;
	TPanel *panKeyMgr;
        TSpeedButton *SpeedButton1;
        TSpeedButton *SpeedButton2;
        TSpeedButton *SpeedButton4;
        TSpeedButton *SpeedButton3;
        TSpeedButton *SpeedButton9;
        TPanel *Panel7;
        TSpeedButton *SpeedButton10;
        TSpeedButton *SpeedButton11;
	TSpeedButton *SpeedButton12;
        TSpeedButton *SpeedButton13;
        TMenuItem *Close1;
	void __fastcall Exit1Click(TObject *Sender);
	void __fastcall Open1Click(TObject *Sender);
	void __fastcall Save1Click(TObject *Sender);
	void __fastcall OldEMU1Click(TObject *Sender);
	void __fastcall lstIdentsClick(TObject *Sender);
	void __fastcall lstCASysChange(TObject *Sender);
	void __fastcall SpeedButton9Click(TObject *Sender);
	void __fastcall SpeedButton2Click(TObject *Sender);
	void __fastcall SpeedButton3Click(TObject *Sender);
	void __fastcall SpeedButton1Click(TObject *Sender);
	void __fastcall lstKeysClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall SpeedButton4Click(TObject *Sender);
	void __fastcall SpeedButton6Click(TObject *Sender);
	void __fastcall SpeedButton5Click(TObject *Sender);
	void __fastcall SpeedButton8Click(TObject *Sender);
	void __fastcall SpeedButton7Click(TObject *Sender);
	void __fastcall SpeedButton11Click(TObject *Sender);
	void __fastcall SpeedButton12Click(TObject *Sender);
	void __fastcall txtNameChange(TObject *Sender);
	void __fastcall txtUAChange(TObject *Sender);
	void __fastcall txtSAChange(TObject *Sender);
	void __fastcall txtOtherChange(TObject *Sender);
	void __fastcall chkPrefClick(TObject *Sender);
	void __fastcall chkSharClick(TObject *Sender);
	void __fastcall chkDCWClick(TObject *Sender);
	void __fastcall chk3Click(TObject *Sender);
	void __fastcall SpeedButton10Click(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall SoftCamkey1Click(TObject *Sender);
        void __fastcall SpeedButton13Click(TObject *Sender);
        void __fastcall Close1Click(TObject *Sender);
        void __fastcall lstKeysDblClick(TObject *Sender);
private:
	__fastcall ~TfrmMain();
	int __fastcall convert_old(unsigned char* buf_emu);
	void __fastcall list_provis(int ca_id);
	AnsiString __fastcall bin2str(byte* buf, int len);
	void __fastcall clear_keys();
public:
	unsigned char bufsrv[0x1000];
	unsigned char bufkeys[0x1000];
	bool provi_changed;
	bool key_changed;
	bool data_changed;
	int CASys;
	AnsiString SOID;
	int ProvID;
        AnsiString AppDir;		// User declarations
	__fastcall TfrmMain(TComponent* Owner);
	int hex2bin(char* in, unsigned char* out);
        int __fastcall get_word(char* s, char** word);
        int __fastcall put_sc_key(char* ca, char* soid, char* key_id, char* key);
        int __fastcall convert_keyid(char* ca, char* keyid);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
